Program Affine_transforms;
uses crt, dos, graph, drivers, aff_proc;

const
p = 3;

type
affine_trans = array[1..6] of real;
affine_data_type = record data : array[1..99] of affine_trans;
                          t    : byte; end;
param = record
   color_depth, delayf, detailf, nnn     : integer;
   include                               : string[99];
   dir_up, point                         : boolean; end;

affine_data_param= record data  : affine_data_type;
                          param : param; end;

var
output                  : string;
endprog                 : boolean;
affine                  : affine_data_type;
active                  : tevent;
parameters              : param;



Procedure points_into_matrix;
var
x1, x2, x3, y1, y2, y3, xx1, xx2, xx3, yy1, yy2, yy3  : real;
a, b, c, d, e, f    : double;

begin
x1:=0; y1:=0; xx1:=0.5; yy1:=1;
x2:=1; y2:=0; xx2:=0.5; yy2:=0.5;
x3:=0; y3:=1; xx3:=0; yy3:=1;

a:=-((xx2*y1 - xx3*y1 - xx1*y2 + xx3*y2 + xx1*y3 - xx2*y3)/(-(x2*y1) + x3*y1 + x1*y2 - x3*y2 - x1*y3 + x2*y3));
b:=-((-(x2*xx1) + x3*xx1 + x1*xx2 - x3*xx2 - x1*xx3 + x2*xx3)/(x2*y1 - x3*y1 - x1*y2 + x3*y2 + x1*y3 - x2*y3));
e:=-((-(x3*xx2*y1)+x2*xx3*y1+x3*xx1*y2-x1*xx3*y2 - x2*xx1*y3 + x1*xx2*y3)/(-(x2*y1) + x3*y1 + x1*y2 - x3*y2 - x1*y3 + x2*y3));
c:=-((y2*yy1 - y3*yy1 - y1*yy2 + y3*yy2 + y1*yy3 - y2*yy3)/(x2*y1 - x3*y1 - x1*y2 + x3*y2 + x1*y3 - x2*y3));
d:=-((-(x2*yy1) + x3*yy1 + x1*yy2 - x3*yy2 - x1*yy3 + x2*yy3)/(x2*y1 - x3*y1 - x1*y2 + x3*y2 + x1*y3 - x2*y3));
f:=-((-(x3*y2*yy1)+x2*y3*yy1+x3*y1*yy2-x1*y3*yy2 - x2*y1*yy3 + x1*y2*yy3)/(x2*y1 - x3*y1 - x1*y2 + x3*y2 + x1*y3 - x2*y3));

end;


Procedure draw_fractal;
type
polygon    = array[1..4] of record x, y : single; end;

const
screen : polygon = ((x:0; y:0), (x:1; y:0), (x:1; y:1), (x:0; y:1));

var
i, j, k, l, ll, max, err_code  : integer;
stop                           : char;
address                        : array[1..20] of byte;
x, y, xx, yy, kk               : double;
xmin, xmax, ymin, ymax         : single;
xmin1, xmax1, ymin1, ymax1          : single;
corr_factor                         : single;
s, s1, s2, r, r1, rx1, ry1          : single;
rx, ry                              : array[1..99] of single;
r_color                             : array[1..99] of byte;
ss                                  : double;
color, color_depth1                 : integer;
fixed                               : boolean;
af_s                                : affine_data_type;
affine_t, zeros                     : byte;
geo                                 : affine_trans;
coord, coord1                       : polygon;
coord_draw                          : array[1..4] of pointtype;


begin
hidemouse;
setcolor(15);
outtextxy(30, 350, 'While the picture is being built, -esc- will stop it. Once stopped,');
outtextxy(30, 365, '-esc- will exit, -enter- will rebuild the picture in its full size');
outtextxy(30, 380, 'and -f- will toggle blinking fixed points on/off.');
outtextxy(30, 400, '-> Press any key to continue!');

zeros:=0;
for i:=1 to affine.t do
  if parameters.include[i]<>'0' then af_s.data[i-zeros]:=affine.data[i] else inc(zeros);
affine_t:=affine.t-zeros;

stop:=readkey;

cleardevice;

 s:=0;
 for i:=1 to affine_t do begin
  s1:= sqrt( (sqr(af_s.data[i][1]+af_s.data[i][4]) + sqr(af_s.data[i][3]-af_s.data[i][2])))/2;
  if s1>s then s:=s1;
  s2:= sqrt( (sqr(af_s.data[i][1]-af_s.data[i][4]) + sqr(af_s.data[i][3]-af_s.data[i][2]))) /2;
  if s2>s then s:=s2;
 end;

 r:=0;
 for i:=1 to affine_t do begin
 rx[i]:=-(af_s.data[i][5] -af_s.data[i][4]*af_s.data[i][5] +af_s.data[i][2]*af_s.data[i][6]);
 rx[i]:=rx[i]/(-1+af_s.data[i][1] +af_s.data[i][2]*af_s.data[i][3]+af_s.data[i][4]-af_s.data[i][1]*af_s.data[i][4]);
 ry[i]:=-(af_s.data[i][6] -af_s.data[i][1]*af_s.data[i][6] +af_s.data[i][3]*af_s.data[i][5]);
 ry[i]:=ry[i]/(-1+af_s.data[i][1] +af_s.data[i][2]*af_s.data[i][3]+af_s.data[i][4]-af_s.data[i][1]*af_s.data[i][4]);
  for j:=1 to affine_t do begin
    rx1:=-(af_s.data[j][5] -af_s.data[j][4]*af_s.data[j][5] +af_s.data[j][2]*af_s.data[j][6]);
    rx1:=rx1/(-1+af_s.data[j][1] +af_s.data[j][2]*af_s.data[j][3]+af_s.data[j][4]-af_s.data[j][1]*af_s.data[j][4]);
    ry1:=-(af_s.data[j][6] -af_s.data[j][1]*af_s.data[j][6] +af_s.data[j][3]*af_s.data[j][5]);
    ry1:=ry1/(-1+af_s.data[j][1] +af_s.data[j][2]*af_s.data[j][3]+af_s.data[j][4]-af_s.data[j][1]*af_s.data[j][4]);
    r1:=sqrt( sqr(rx[i]-rx1)+sqr(ry[i]-ry1) );
    if r1>r then r:=r1;
  end;
 end;


xmin:=-99999; xmax:=99999; ymin:=-99999; ymax:=99999;
for i:=1 to affine_t do begin
{ geo[1]:=Sqrt(Sqr(affine.data[i][1])+Sqr(affine.data[i][3]));
 geo[2]:=Sqrt(Sqr(affine.data[i][2])+Sqr(affine.data[i][4]));
  if geo[1]<>0 then begin kk:= affine.data[i][1]/geo[1];
    if (kk<>0) then begin
      geo[3]:=ArcTan (sqrt (1-sqr (kk)) /kk);
      if kk=-1 then geo[3]:=Pi;
      end else begin kk:= affine.data[i][3]/geo[1];
      if (kk<1) and (kk>-1) then geo[3]:=ArcTan (kk / sqrt (1-sqr (kk)))
        else geo[3]:=kk*Pi/2;
    end end else geo[3]:=0;
  if geo[2]<>0 then begin kk:= affine.data[i][4]/geo[2];
    if (kk<>0) then begin
      geo[4]:=ArcTan (sqrt (1-sqr (kk)) /kk);
      if kk=-1 then geo[4]:=Pi;
      end else begin kk:= - affine.data[i][2]/geo[2];
      if (kk<1) and (kk>-1) then geo[4]:=ArcTan (kk / sqrt (1-sqr (kk)))
        else geo[4]:=kk*pi/2;
    end end else geo[4]:=0;}
 if (rx[i]-r/(1-s))>xmin then xmin:=rx[i]-r/(1-s);
 if (rx[i]+r/(1-s))<xmax then xmax:=rx[i]+r/(1-s);
 if (ry[i]-r/(1-s))>ymin then ymin:=ry[i]-r/(1-s);
 if (ry[i]+r/(1-s))<ymax then ymax:=ry[i]+r/(1-s);
 end;

repeat

cleardevice;
if (xmax-xmin)/640 > (ymax-ymin)/480 then
      corr_factor:=(xmax-xmin)/625 else corr_factor:=(ymax-ymin)/470;
if corr_factor=0 then exit;

if parameters.nnn=0 then begin
 max:=1;
 ss:=s;
 repeat
  inc(max);
  ss:=ss*s;
 until parameters.detailf/(2*affine_t)*ss<corr_factor; end
else max:=parameters.nnn;

color_depth1:=parameters.color_depth;
if (color_depth1<0) then color_depth1:=0;
if (color_depth1>max) then color_depth1:=max;

xmin1:=0; xmax1:=0; ymin1:=0; ymax1:=0;


for i:=1 to max do address[i]:=1;

repeat
if parameters.point then begin
    x:=0; y:=0;
    for l:=1 to max do begin
      if parameters.dir_up then ll:=l else ll:=max+1-l;
      xx:=af_s.data[address[ll]][1]*x+af_s.data[address[ll]][2]*y+af_s.data[address[ll]][5];
      yy:=af_s.data[address[ll]][3]*x+af_s.data[address[ll]][4]*y+af_s.data[address[ll]][6];
      x:=xx; y:=yy;
     end;
    if x<xmin1 then xmin1:=x;
    if x>xmax1 then xmax1:=x;
    if y<ymin1 then ymin1:=y;
    if y>ymax1 then ymax1:=y;
    color:=15; if color_depth1<>0 then
       if parameters.dir_up then for i:=1 to color_depth1 do color:=(address[max-i+1]*i+color) mod 14 +1
               else for i:=1 to color_depth1 do color:=(address[i]*i+color) mod 14 +1;
    putpixel(round((x-xmin)/corr_factor)+3, 477-round((y-ymin)/corr_factor), color);
    if keypressed then stop:=readkey;
    if parameters.delayf<>0 then delay(parameters.delayf);
   end
 else begin
   coord:=screen;
    for l:=1 to max do begin
      if parameters.dir_up then ll:=l else ll:=max+1-l;
      for i:=1 to 4 do begin
      coord1[i].x:=af_s.data[address[ll]][1]*coord[i].x+af_s.data[address[ll]][2]*coord[i].y+af_s.data[address[ll]][5];
      coord1[i].y:=af_s.data[address[ll]][3]*coord[i].x+af_s.data[address[ll]][4]*coord[i].y+af_s.data[address[ll]][6];
      end;
      coord:=coord1;
     end;
    for i:=1 to 4 do begin
     if coord[i].x<xmin1 then xmin1:=coord[i].x;
     if coord[i].x>xmax1 then xmax1:=coord[i].x;
     if coord[i].y<ymin1 then ymin1:=coord[i].y;
     if coord[i].y>ymax1 then ymax1:=coord[i].y;
    end;
    color:=15; if color_depth1<>0 then
       if parameters.dir_up then for i:=1 to color_depth1 do color:=(address[max-i+1]*i+color) mod 14 +1
               else for i:=1 to color_depth1 do color:=(address[i]*i+color) mod 14 +1;

    for i:=1 to 4 do begin
     coord_draw[i].x:=round((coord[i].x-xmin)/corr_factor)+3;
     coord_draw[i].y:=477-round((coord[i].y-ymin)/corr_factor);
    end;

    setcolor(color);
    setfillstyle(1, color);
    fillpoly(4, coord_draw);

    if keypressed then stop:=readkey;
    if parameters.delayf<>0 then delay(parameters.delayf);

 end;

  j:=max;
  repeat
    inc(address[j]);
    if (address[j]<=affine_t) and (j<max) then repeat inc(j);
                 until not (address[j]<=affine_t) or (j=max);
    if address[j]>affine_t then begin
                             address[j]:=1;
                             dec(j); end;
  until (j=max) or (j=0);
until (j=0) or (stop=#27);

showmouse;
fixed:=false;
stop:=#1;
j:=0;
repeat
  if keypressed then stop:=readkey;
  if (stop='f') and (j=0) then
    if fixed then
      for i:=1 to affine_t do begin
        putpixel(round((rx[i]-xmin)/corr_factor)+3, 477-round((ry[i]-ymin)/corr_factor), r_color[i]);
        fixed:=false;
     end else
      for i:=1 to affine_t do begin
        r_color[i]:=getpixel(round((rx[i]-xmin)/corr_factor)+3, 478-round((ry[i]-ymin)/corr_factor));
        putpixel(round((rx[i]-xmin)/corr_factor)+3, 477-round((ry[i]-ymin)/corr_factor), 15);
        fixed:=true;
      end;
inc(j); if j>10 then j:=0; delay(10);
until stop in [#27, #13];

hidemouse;
xmin:=xmin1; xmax:=xmax1; ymin:=ymin1; ymax:=ymax1;
until stop=#27;
end;


Procedure matrixedit;
var
done                     : boolean;
act1                     : char;
which_trans, which_var   : byte;
err_code, i              : integer;
const
x : array[1..6] of integer =(20, 220, 20, 220, 460, 460);
y : array[1..6] of integer = (120, 120, 180, 180, 120, 180);

begin
done:=false; which_trans:=1; which_var:=1;
cleardevice;
setcolor(15);
repeat
  act1:=' ';
  settextstyle(0, 0, 1);
  outtextxy(10, 400, 'Press a thru f to edit single variables, x for all');
  outtextxy(10, 415, 'Press page-up or page-down to scroll thru transforms');
  outtextxy(10, 430, 'Press Esc or Enter to return to main menu');
  barr(0,0, 15, 15, 640, 220);
  settextstyle(0, 0, 2);
  Str(which_trans-1, output);
  outtextxy(20, 40, 'transformation #:  '+output);
  for i:=1 to 6 do begin
    Str(affine.data[which_trans][i]:2:2, output);
    outtextxy(x[i], y[i], Chr(Ord('a')-1+i)+'= '+output);
    end;
  repeat
    if keypressed then act1:=readkey;
    getmouseevent(active);
    if active.buttons<>0 then act1:=#27;
    if act1=#0 then act1:=readkey;
  until act1 in [#27, #13, 'Q', 'I', 'a'..'f', 'x'];
  case act1 of
    'Q' : begin dec(which_trans); {page up}
                if which_trans<1 then which_trans:=affine.t; end;
    'I' : begin inc(which_trans); {page down}
                if which_trans>affine.t then which_trans:=1; end;
    'a'..'f' : begin which_var:=Ord(act1)-Ord('a')+1;
                     output:= No(input(x[which_var]+60, y[which_var], 10, 2));
                     if output<>'' then Val(output, affine.data[which_trans][which_var], err_code);
                     end;
    'x' : for which_var:=1 to 6 do begin
              output:= No(input(x[which_var]+60, y[which_var], 10, 2));
              if output='' then break;
              Val(output, affine.data[which_trans][which_var], err_code);
              end;
    #27, #13 : done:= true;
    end;
until done;
end;

Procedure geom_edit;
var
done                     : boolean;
act1, act2               : char;
which_trans, which_var   : byte;
err_code, i              : integer;
geometric_trans          : affine_trans;
kk                       : real;
const
x : array[1..6] of integer = (20, 20, 220, 220, 460, 460);
y : array[1..6] of integer = (120, 180, 120, 180, 120, 180);
name : array[1..6] of char = ('r', 's', 'a', 'b', 'e', 'f');

begin
done:=false; which_trans:=1; which_var:=1;
cleardevice;
setcolor(15);
settextstyle(0, 0, 1);
outtextxy(10, 400, 'Press r, s, a, b, e, f to edit single variables, x for all');
outtextxy(10, 415, 'r/s (horiz/vert scaling) a/b (horiz/vert rot.) e/f (horiz/vert transl.)' );
outtextxy(10, 435, 'Press page-up or page-down to scroll thru transforms');
outtextxy(10, 450, 'Press Esc or Enter to return to main menu');
act1:='Q';
repeat
  if act1 in ['Q','I'] then begin
  barr(0,0, 15, 15, 640, 110);
  settextstyle(0, 0, 2);
  Str(which_trans-1, output);
  outtextxy(20, 40, 'transformation #:  '+output);
  geometric_trans[1]:=Sqrt(Sqr(affine.data[which_trans][1])+Sqr(affine.data[which_trans][3]));
  geometric_trans[2]:=Sqrt(Sqr(affine.data[which_trans][2])+Sqr(affine.data[which_trans][4]));
  if geometric_trans[1]<>0 then begin
    kk:= affine.data[which_trans][1]/geometric_trans[1];
    if (kk<>0) then begin
      geometric_trans[3]:=(180/PI)*ArcTan (sqrt (1-sqr (kk)) /kk); {Arccos}
      if kk=-1 then geometric_trans[3]:=180;
      end else begin
      kk:= affine.data[which_trans][3]/geometric_trans[1];
      if (kk<1) and (kk>-1) then
        geometric_trans[3]:=(180/PI)*ArcTan (kk / sqrt (1-sqr (kk))) {Arcsin}
        else geometric_trans[3]:=kk*90;
    end end else geometric_trans[3]:=0;
  if geometric_trans[2]<>0 then begin
    kk:= affine.data[which_trans][4]/geometric_trans[2];
    if (kk<>0) then begin
      geometric_trans[4]:=(180/PI)*ArcTan (sqrt (1-sqr (kk)) /kk); {Arccos}
      if kk=-1 then geometric_trans[4]:=180;
      end else begin
      kk:= - affine.data[which_trans][2]/geometric_trans[2];
      if (kk<1) and (kk>-1) then
        geometric_trans[4]:=(180/PI)*ArcTan (kk / sqrt (1-sqr (kk))) {Arcsin}
        else geometric_trans[4]:=kk*90;
    end end else geometric_trans[4]:=0;
  geometric_trans[5]:=affine.data[which_trans][5];
  geometric_trans[6]:=affine.data[which_trans][6];
  end;

  barr(0,0, 15, 120, 640, 220);
    for i:=1 to 6 do begin
    Str(geometric_trans[i]:2:2, output);
    outtextxy(x[i], y[i], name[i]+'= '+output);
    end;
  act1:=' ';
  repeat
    if keypressed then act1:=readkey;
    getmouseevent(active);
    if active.buttons<>0 then act1:=#27;
    if act1=#0 then act1:=readkey;
  until act1 in [#27, #13, 'Q', 'I', 'r', 's', 'a', 'b', 'e', 'f', 'x'];
  act2:=act1;
  for i:=1 to 6 do if act1=name[i] then act2:=Chr(Ord('a')-1+i);
  act1:=act2;
  case act1 of
    'Q' : begin dec(which_trans); {page up}
                if which_trans<1 then which_trans:=affine.t; end;
    'I' : begin inc(which_trans); {page down}
                if which_trans>affine.t then which_trans:=1; end;
    'a'..'f' : begin which_var:=Ord(act1)-Ord('a')+1;
                     output:= No(input(x[which_var]+60, y[which_var], 10, 2));
                     if output<>'' then Val(output, geometric_trans[which_var], err_code);
                     end;
    'x' : for which_var:=1 to 6 do begin
              output:= No(input(x[which_var]+60, y[which_var], 10, 2));
              if output='' then break;
              Val(output, geometric_trans[which_var], err_code);
              end;
    #27, #13 : done:= true;
    end;
if act1 in ['a'..'f', 'x'] then begin
 affine.data[which_trans][1]:=geometric_trans[1]*Cos((Pi/180)*geometric_trans[3]);
 affine.data[which_trans][2]:=-geometric_trans[2]*Sin((Pi/180)*geometric_trans[4]);
 affine.data[which_trans][3]:=geometric_trans[1]*Sin((Pi/180)*geometric_trans[3]);
 affine.data[which_trans][4]:=geometric_trans[2]*Cos((Pi/180)*geometric_trans[4]);
 affine.data[which_trans][5]:=geometric_trans[5];
 affine.data[which_trans][6]:=geometric_trans[6]; end

until done;
end;

Procedure examples;
const
no_of_ex = 8;

figure : array[1..no_of_ex] of array[1..4] of affine_trans
=(
 ((0.5,0,0,0.5,0,0), (0.5,0,0,0.5,0.5,0), (0.5,0,0,0.5,0,0.5), (0,0,0,0,0,0)),
 ((0.5,0,0,0.5,0,0), (0,-0.5,0.5,0,0.5,0), (0,0.5,-0.5,0,0,0.5), (0,0,0,0,0,0)),
 ((0.5,0,0,0.5,0,0), (0,-0.5,-0.5,0,0.5,0), (0,0.5,-0.5,0,0,0.5), (0,0,0,0,0,0)),
 ((0.5,0,0.2,0.5,0,0), (0.2,0.4,-0.4,0,0.3,0.2), (-0.3,0.2,-0.55,0,0,0.2), (0.3,0.45,0,0.4,0.2,0.1)),
 ((0.2,0.3,0,-0.5,0.2,0), (0,-0.2,0.5,0,1,0.1), (0.1,0.5,-0.5,0,0,0.6), (0.3,0,0.4,0.5,0.8,1.3)),
 ((0.8,0.6,0,0.5,0.3,0), (0.5,-0.2,0,0.2,-1,0.1), (0,0.5,0.5,0.2,0.4,0.6), (0.3,0,0.4,-0.5,0.8,1.3)),
 ((0.333,0,0,0.333,0,0), (0.16,-0.289,0.289,0.16,0.333,0), (0.16,0.289,-0.289,0.16,0.5,0.289), (0.333,0,0,0.333,0.666,0)),
 ((0.24,0,0.24,0,0,0), (0.24,0,0.24,0,0.666,0.666), (0,0,0,0,0,0), (0,0,0,0,0,0))
);
n_of_t : array[1..no_of_ex] of byte = (3,3,3,4,4,4,4,2);
d = 40;

var
choice  : char;
i, ch   : integer;

begin
hidemouse;
cleardevice;
setcolor(15);
outtextxy(150, 60+d  , '1 .. Right Sierpinski Gasket');
outtextxy(150, 60+2*d, '2 .. Columns');
outtextxy(150, 60+3*d, '3 .. Snake');
outtextxy(150, 60+4*d, '4 .. Chinese?');
outtextxy(150, 60+5*d, '5 .. Fireworks');
outtextxy(150, 60+6*d, '6 .. Palmleaf');
outtextxy(150, 60+7*d, '7 .. Koch Curve');
outtextxy(150, 60+8*d, '8 .. Cantor Set');
repeat
choice:=readkey;
until choice in ['1'..Chr(Ord('1')+no_of_ex-1), #27];

Val(choice, ch, i);
affine.t:=n_of_t[ch];
for i:=1 to affine.t do
  affine.data[i]:=figure[ch][i];

end;



Procedure change_param;
var
err_code       : integer;
act            : char;
value, i       : integer;
space          : integer;

const
d = 40;

begin
cleardevice;

repeat
space:=0;
setcolor(15);
barr(0,0,70,d,640,4*d);
 Str(parameters.color_depth, output);
 outtextxy(80, 1*d+space, 'c .. color depth:  '+output);
 Str(affine.t, output);
 outtextxy(80, 2*d+space, 'n .. # of transforms:  '+output);
 Str(parameters.delayf, output);
 outtextxy(80, 3*d+space, 'd .. delay factor:  '+output);
barr(0,0,70,4*d,640,8*d);
 output:=parameters.include; delete(output, affine.t+1, 99);
 outtextxy(80, 4*d+space, 'i .. included transforms (1=yes, 0=no): '+output);
 if parameters.dir_up then output:='see fractal fast' else output:='plot fractal by address';
 inc(space,20);
 outtextxy(80, 5*d+space, 'm .. method used: '+output);
 if parameters.point then output:='one point' else output:='entire screen';
 outtextxy(80, 6*d+space, 's .. starting with: '+output);
barr(0,0,70,8*d,640,10*d);
 Str(parameters.detailf, output);
 outtextxy(80, 7*d+space, 'l .. detail factor (1= low detail, 30000= high detail): '+output);
 Str(parameters.nnn, output);
 outtextxy(80, 8*d+space, 'a .. max length of addresses: '+output+'  (if 0 then use detail factor)');

act:=readkey;
case act of
  'c' : begin
          Val(No(input(270, d, 3, 1)), value, err_code);
          if (value>=0) and (value<99) then parameters.color_depth:=value;
        end;
  'n' : begin
          Val(No(input(300, 2*d, 3, 1)), value, err_code);
          if (value>0) and (value<99) then affine.t:=value;
        end;
  'd' : begin
          Val(No(input(275, 3*d, 3, 1)), value, err_code);
          if (value>=0) and (value<999) then parameters.delayf:=value;
        end;
  'i' : begin
          output:=input(120, 4*d+20, affine.t+5, 1);
          for i:=99 downto 1 do if not (output[i] in ['1', '0']) then delete(output, i, 1);
          insert(output, parameters.include, 1);
        end;
  'm' : if parameters.dir_up then parameters.dir_up:=false else parameters.dir_up:=true;
  's' : if parameters.point then parameters.point:=false else parameters.point:=true;
  'l' : begin
          Val(No(input(275, 7*d+space+20, 3, 1)), value, err_code);
          if (value>0) and (value<31000) then parameters.detailf:=value;
        end;
  'a' : begin
          Val(No(input(275, 8*d+space+20, 3, 1)), value, err_code);
          if (value>=0) and (value<15) then parameters.nnn:=value;
        end;
  end;

until act in [#27,#13];

end;


Procedure save_data;

var
data       : affine_data_param;
datafile   : file of affine_data_param;
name       : string;

begin
data.data:=affine;
data.param:=parameters;
setcolor(15);
outtextxy(100,360,'Enter a name to save under: ');
name:=input(340, 360, 20, 1);
bar(100,360,640,400);
if name<>'                    ' then begin
  assign(datafile,name);
  rewrite(datafile);
  write(datafile, data);
  close(datafile);    end;
end;

procedure load_data;
var
data       : affine_data_param;
datafile   : file of affine_data_param;
name       : string;

begin
setcolor(15);
outtextxy(100,360,'Enter a file name to load from: ');
name:=input(380, 360, 20, 1);
bar(100,360,640,400);
assign(datafile,name);
if fsearch(name,'.')<>'' then begin
   reset(datafile);
   read(datafile,data);
   close(datafile);
   end
   else begin sound(400); delay(300);
              sound(300); delay(300);
              sound(200); delay(300);
              nosound; end;

affine:=data.data;
parameters:=data.param;
end;


{************************ main screen ***************}
procedure menu1;
var
i : integer;

begin
setcolor(14);
settextstyle(0, 0, 1);
outtextxy(1,10, 'IFS generator ver 1.1 - by Mark Volchek (c) 1998');

barr(1, 1, 20, 432, 618, 475);
settextstyle(0, 0, 1);
for i:=1 to 7 do barr(1, 2, 20+75*i-2, 432, 20+75*i, 475);

i:=1;
setcolor(15);
outtextxy(100, 60+i*30, 'Press -d- draw fractal using current transforms');
setcolor(2);
Outtextxy(-55+(i)*75+18, 444,  'draw');
Outtextxy(-55+(i)*75+8, 456,  'fractal');

i:=2;
setcolor(7);
outtextxy(100, 60+i*30, 'Press -p- to change paramaters');
setcolor(0);
Outtextxy(-55+(i)*75+10, 444, 'change');
Outtextxy(-55+(i)*75+11, 456, 'params');

i:=3;
setcolor(7);
outtextxy(100, 60+i*30, 'Press -m- to edit transforms in matrix form');
setcolor(0);
Outtextxy(-55+(i)*75+8, 438, 'edit in');
Outtextxy(-55+(i)*75+13, 450, 'matrix');
Outtextxy(-55+(i)*75+17, 462, 'form');

i:=4;
setcolor(7);
outtextxy(100, 60+i*30, 'Press -g- to edit transforms in geometric coeff');
setcolor(0);
Outtextxy(-55+(i)*75+8, 438,  'edit in');
Outtextxy(-55+(i)*75+5, 450, 'geo-coef');
Outtextxy(-55+(i)*75+17, 462, 'form');

i:=5;
setcolor(7);
outtextxy(100, 60+i*30, 'Press -e- for preset examples');
setcolor(0);
Outtextxy(-55+(i)*75+13, 444, 'preset');
Outtextxy(-55+(i)*75+6, 456, 'examples');

i:=6;
setcolor(8);
outtextxy(100, 60+i*30, 'Press -s- to save current transform data');
setcolor(0);
Outtextxy(-55+(i)*75+18, 450, 'save');

i:=7;
setcolor(8);
outtextxy(100, 60+i*30, 'Press -l- to load current transform data');
setcolor(0);
Outtextxy(-55+(i)*75+18, 450, 'load');

i:=8;
setcolor(3);
outtextxy(100, 60+i*30, 'Press -esc- to exit');
setcolor(4);
Outtextxy(-55+(i)*75+17, 450, 'exit');

barr(1,8, 476, 210, 630, 300);
setcolor(3);
Outtextxy(480, 220, 'Current Parameters');
Str(affine.t, output);
Outtextxy(490, 245, '# of transf = '+output);
Str(parameters.color_depth, output);
Outtextxy(490, 265, 'color depth = '+output);
Str(parameters.delayf, output);
Outtextxy(490, 285, 'delay factor= '+output);

end;



Procedure main;

var
i           : integer;
act         : char;
menu_option : byte;
x, y        : integer;

const
menu_max=8;

begin
endprog:=false;
for i:=1 to 6 do affine.data[1][i]:=0;
for i:=2 to 99 do affine.data[i]:=affine.data[1];
affine.t:=3;

parameters.color_depth:=1;
parameters.delayf:=0;
parameters.detailf:=10;
parameters.dir_up:=true;
parameters.point:=true;
for i:=1 to 99 do insert('1',parameters.include,1);

initevents;
menu_option:=1;
act:='a';

repeat
showmouse;
if act in ['a'..'z'] then begin hidemouse;
                                cleardevice;
                                menu1; end;
barr(0, 0, 55,80, 98, 310);
setcolor(14);
if menu_option<1 then menu_option:=menu_max;
if menu_option>menu_max then menu_option:=1;
settextstyle(0,0,1);
outtextxy(84, 60+menu_option*30, Chr(26));
showmouse;
act:=' ';
  repeat
    if keypressed then act:=readkey;
    getmouseevent(active);
    if active.buttons<>0 then begin
                   x:=8*mousewhere.x+4;
                   y:=8*mousewhere.y+4;
                   if (y>430) then menu_option:=trunc((x-20)/75)+1;
                   act:=#13;
                   end;
  until act in [#27, #13, #0, 'm', 'p', 'd', 's', 'l', 'g', 'e'];
  if act=#0 then act:=readkey;
  if act=#13 then case menu_option of
                   1 : act:='d';
                   2 : act:='p';
                   3 : act:='m';
                   4 : act:='g';
                   5 : act:='e';
                   6 : act:='s';
                   7 : act:='l';
                   8 : act:=#27;
                   end;
  case act of
    'd' : draw_fractal;
    'p' : change_param;  {2}
    'm' : matrixedit; {3}
    'g' : geom_edit;
    'e' : examples;
    's' : save_data;  {6}
    'l' : load_data;
    'H' : dec(menu_option);
    'P' : inc(menu_option);
    #27 : endprog:=true;
    end;
if endprog then begin setcolor(3);
                      settextstyle(0,0,1);
                      outtextxy(100, 360, 'Are you sure? (y/n) - All unsaved data will be lost!');
                      repeat act:=readkey; until act in ['y','n'];
                      barr(0, 0, 99, 360, 640, 380);
                      if act='n' then begin endprog:=false; act:=' '; end;
                      end;
until endprog;
end;





begin
initgraphics;
main;
restorecrtmode;
clrscr;
end.